//Copyright (C) 2002  Daniel De Graaf

#include "Global.h"

static void get_arglist(BYTE* argptr, HANDLE m, WORD* numrq, WORD* nummnu, HANDLE* menuhlst) {
	char* txt;
	short type,x,y;
	IntArgTo(type);
	if (type == 1) {             //text
		StrArgTo(txt);
		IntArgTo(x);
		IntArgTo(y);
		DialogAddText(m,x,y,txt);
	} else if (type == 2) {     //request
		StrArgTo(txt);
		IntArgTo(x);
		IntArgTo(y);
		OIntArgTo(type, 100); //actually width
		DialogAddRequest(m,x,y,txt, 101*(*numrq)++ , 100, type);
	} else if (type == 3) {    //PullDown
		StrArgTo(txt);
		IntArgTo(x);
		IntArgTo(y);
		get_file(4, loc(type));
		HeapLock(fileh);
		BYTE* file=HToESI(fileh);
		if (*file != LIST_TAG) return;
		DialogAddPulldown(m,x,y,txt,
			menuhlst[*nummnu] = GetPopupMenu(0, file), //is a popup with no title
			*nummnu+1);
		(*nummnu)++;
		HeapUnlock(fileh);
	}
}

void F34(___args___) {
	short w, h, tmp1=0, tmp2=0, numrq=0, nummenu=0;
	WORD dx,dy;
	char* title=0;
	IntArgTo(w);
	IntArgTo(h);
	OIntArgTo(dx, 0xFFFF);
	OIntArgTo(dy, 0xFFFF); //center if not used
	if (atype == STR_TAG) {
		title = GetStrnArg(argptr);
		BIntArgTo(tmp1, BT_NONE, BT_GOTO);
		BIntArgTo(tmp2, BT_NONE, BT_GOTO);
	}
	MustBe(LIST_TAG);	argptr--; //pass first list tag
	MustBe(LIST_TAG);
	HANDLE m=DialogNewSimple(w,h);
	if (title) DialogAddTitle(m, title, tmp1, tmp2);

	HANDLE* menuh=malloc(52);
	while (atype != END_TAG) {
		get_arglist(argptr-1, m, loc(numrq), loc(nummenu), menuh);
		SkipArg(argptr); //the argument is a normal list, nicely skipped
	}
	char* rqb=malloc(numrq*101+2);
	short* pdb=malloc(nummenu*2+2);
	memset(rqb,0,numrq*101);
	memset(pdb,0,nummenu);
	short dlg = DialogDo(m, dx, dy, rqb, pdb);
	for(tmp1=0;tmp1 < nummenu; tmp1++) HeapFree(menuh[tmp1]);
	HeapFree(m);
	free(menuh);
	if (dlg != KEY_ENTER) {
		return_int(dlg);
		free(rqb); free(pdb);
		return;
	}
	tmp2=2;
	for(tmp1=0;tmp1 < nummenu; tmp1++)
		tmp2 += 2 + (pdb[tmp1] != 0);
	for(tmp1=0;tmp1 < numrq; tmp1++)
		tmp2 += strlen(rqb+101*tmp1) + 3;
	init(w=tmp2); tmp2=1; //keep tmp2 for later
	ret[0]=END_TAG;

	for(tmp1=0; tmp1 < nummenu; tmp1++) {
		if ((ret[tmp2++] = pdb[tmp1])) ret[tmp2++]=1;
		ret[tmp2++]=POSINT_TAG;
	}
	for(tmp1=0; tmp1 < numrq; tmp1++) {
		ret[tmp2++]=0;
		strcpy(ret+tmp2,rqb+101*tmp1);
		tmp2 += strlen(rqb+101*tmp1)+1;
		ret[tmp2++]=STR_TAG;
	}
	ret[tmp2++]=LIST_TAG;
/*
	if (tmp2 != w) {
		memmove(ret+w-tmp2,ret,tmp2); //move to the end of the block
	}
*/
	free(rqb); free(pdb);
}
