//Copyright (C) 2002  Daniel De Graaf

#include "Global.h"

void F33(___args___) {
	WORD WasOn;
	HANDLE light=_get_file(0,loc(WasOn), argptr); SkipArg(argptr);
	HANDLE dark =_get_file(0,loc(WasOn), argptr); SkipArg(argptr);
	if (!light || !dark) return;
	WasOn=IsGrayMode();
	SCR_RECT rect;
	rect.l = TI89 ? 0x0000A064 : 0x0000F080;
	char* lcd=0;
	if (!WasOn) {
		lcd=alloca(LCD_SIZE);
		LCD_save (lcd);
		GrayOn();
	}
	SetPlane(LIGHT_PLANE);
	BitmapPut(0, 0, HeapDeref(light) + 2, loc(rect), A_REPLACE);
	SetPlane(DARK_PLANE);
	BitmapPut(0, 0, HeapDeref(dark) + 2, loc(rect), A_REPLACE);
	if (WasOn) return;
	char* command;
	OStrArgTo(command, 0);
	if (!command)
		ngetchx();
	else TRY //So no errors cause a crash
		push_parse_text(command);
		HANDLE tmp = HS_popEStack();
		NG_execute(tmp, 0);
		HeapFree(tmp);
		ER_success();
	ENDTRY
	GrayOff();
	LCD_restore(lcd);
}
